import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileOtherHistory } from "../entities/ProfileOtherHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import {
  CreateProfileEmployeeOther,
  ProfileOther,
  UpdateProfileOther,
} from "../entities/ProfileOther";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/other")
@Tags("ProfileOther")
@Security("bearerAuth")
export class ProfileOtherEmployeeController extends Controller {
  private profileRepository = AppDataSource.getRepository(ProfileEmployee);
  private otherRepository = AppDataSource.getRepository(ProfileOther);
  private otherHistoryRepository = AppDataSource.getRepository(ProfileOtherHistory);

  @Get("user")
  public async getOtherUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileRepository.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const lists = await this.otherRepository.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("{profileId}")
  public async getOther(@Path() profileId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileId);
    const lists = await this.otherRepository.find({
      where: { profileEmployeeId: profileId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("admin/history/{otherId}")
  public async otherAdminHistory(@Path() otherId: string, @Request() req: RequestWithUser) {
    const _record = await this.otherRepository.findOneBy({ id: otherId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, otherId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }
    const record = await this.otherHistoryRepository.find({
      where: { profileOtherId: otherId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{otherId}")
  public async otherHistory(@Path() otherId: string) {
    const record = await this.otherHistoryRepository.find({
      where: { profileOtherId: otherId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newOther(@Request() req: RequestWithUser, @Body() body: CreateProfileEmployeeOther) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepository.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileOther();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileOtherHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.otherRepository.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileOtherId = data.id;
    await this.otherHistoryRepository.save(history, { data: req });

    return new HttpSuccess(data.id);
  }

  @Patch("{otherId}")
  public async editOther(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileOther,
    @Path() otherId: string,
  ) {
    const record = await this.otherRepository.findOneBy({ id: otherId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    const history = new ProfileOtherHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileOtherId = otherId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.otherRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.otherHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลข้อมูลอื่นๆ
   * @summary API ลบข้อมูลข้อมูลอื่นๆ
   * @param otherId คีย์ข้อมูลอื่นๆ
   */
  @Patch("update-delete/{otherId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() otherId: string,
  ) {
    const record = await this.otherRepository.findOneBy({ id: otherId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileOtherHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileOtherId = otherId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.otherRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.otherHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{otherId}")
  public async deleteOther(@Path() otherId: string, @Request() req: RequestWithUser) {
    const _record = await this.otherRepository.findOneBy({ id: otherId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }

    await this.otherHistoryRepository.delete({
      profileOtherId: otherId,
    });

    const result = await this.otherRepository.delete({ id: otherId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
